//******************************************************
// CAPAX-Xtd Expert : Domotique
// V1.0 Le 14/08/2018
// CAPAX SYSTEMS by www.infoconsult.tn
//******************************************************

#include <LiquidCrystal.h>
#include <SPI.h> // Ajout de la bibliothèque SPI
#include <dht.h>
dht DHT;

#define LM35_pin A15
#define ldr_pin A3

#define DHT22_pin A6
#define BP_pin 47
#define Led_R_pin 43
#define Led_O_pin 44
#define Led_V_pin 42
#define Led_B_pin 9
#define Buzzer_pin 10

#define echo_pin 25
#define trig_pin 23
#define MCC_pin 2
#define IN1_pin 3
#define IN2_pin 5


# define CS 53
# define aV1 A3
# define aV2 A4


float Q = 110.0/1024.0; // = 1.1*100/1024
float T_LM35;
float chkDHT22;
float T_DHT22;
float H;
float T;
float Dist;

int iV1;
int iV2;
int iDV;
float Rldr;
float Rldr0;
int ValLed;
int valMCP;

int T_lim = 35;
float d_lim = 12.0;


bool bBP = 0;

bool bLedR = 0;
unsigned long timerLedR0=0;
unsigned long timerLedR=0;
unsigned long tempoLedR = 4000;

bool bLedV = 0;
unsigned long timerLedV0=0;
unsigned long timerLedV=0;
unsigned long tempoLedV = 4000;

int VitMCC=150;
bool bMCC = 0;
unsigned long timerMCC0=0;
unsigned long timerMCC=0;
unsigned long tempoMCC = 3000;

bool bDist = 0;
unsigned long timerDist0=0;
unsigned long timerDist=0;
unsigned long tempoDist = 5000;

const int rs=34;
const int en=33;
const int d4=32;
const int d5=31;
const int d6=30;
const int d7=29;
LiquidCrystal lcd(rs,en,d4,d5,d6,d7);

void setup() {
  lcd.begin(16, 2);
  SPI.begin(); // Initialisation de la bibliothèque SPI
  pinMode(BP_pin,INPUT);
  pinMode(Led_R_pin,OUTPUT);
  pinMode(Led_R_pin,OUTPUT);
  pinMode(Led_O_pin,OUTPUT);
  pinMode(Led_V_pin,OUTPUT);
  pinMode(Led_B_pin,OUTPUT);
  pinMode(Buzzer_pin,OUTPUT);

  pinMode(echo_pin,INPUT);
  pinMode(trig_pin,OUTPUT);
  pinMode(MCC_pin,OUTPUT);
  pinMode(IN1_pin,OUTPUT);
  pinMode(IN2_pin,OUTPUT);
  pinMode(CS,OUTPUT);

  digitalWrite(IN1_pin,HIGH);
  digitalWrite(IN2_pin,LOW);
  analogWrite(MCC_pin,0);

  lcd.print("T=");
  lcd.setCursor(8, 0);
  lcd.print("H=");
  lcd.setCursor(0, 1);
  lcd.print("D=");
  lcd.setCursor(8, 1);
  lcd.print("R=");

  iV1 = analogRead(A3); // lecture numérique de V1 à partir de la pin 'A3'
  iV2 = analogRead(A4); // lecture numérique de V2 à partir de la pin 'A4'
  iDV = iV1-iV2;
  Rldr0=10000.0*(1024-iV1)/(iV1-iV2);
  valMCP = int((Rldr0-52.0)/39.0625);
  MCP41010Write(valMCP);
}

void loop() {

// test BP
  if (bLedR == HIGH){
    timerLedR = millis()-timerLedR0;
    if (timerLedR >=tempoLedR) {
      bLedR = LOW;
      BP_OFF();
    }
  }
  else{
    bBP = digitalRead(BP_pin);
    if (bBP==LOW) {
      bLedR = HIGH;
      BP_ON();
      timerLedR0 = millis();
      timerLedR = millis()-timerLedR0;
      while (bBP==LOW) {
        bBP = digitalRead(BP_pin);
        timerLedR = millis()-timerLedR0;
        if (timerLedR >=4000) {
          bLedR = LOW;
          BP_OFF();
        }
      }
    }
  }
// fin test BP

// temppérature et humidité
  
  analogReference(INTERNAL1V1);// Les 2 mesures successives séparées par un délais sont nécessaires à cause du changement de analogReference
  T_LM35 = Q * analogRead(LM35_pin); //convertion la tension en température
  delay(10);
  T_LM35 = Q * analogRead(LM35_pin); //convertion la tension en température
  chkDHT22 = DHT.read22(DHT22_pin);
  T_DHT22 = DHT.temperature;
  H = DHT.humidity;
  T = (T_DHT22+T_LM35)/2;
  lcd.setCursor(2, 0);
  lcd.print(T,1);
  lcd.setCursor(10, 0);
  lcd.print(H,1);

  if (bMCC==1) {
    timerMCC = millis()-timerMCC0;
    if (timerMCC >= tempoMCC) {
      analogWrite(MCC_pin, 0);
//      timerMCC0 = 0;
//      timerMCC = 0;
      bMCC = LOW;
    }
  }
  else{
    if (T>T_lim){
      bMCC = HIGH;
      analogWrite(MCC_pin, VitMCC);
      timerMCC0 = millis();
      timerMCC = millis()-timerMCC0;
    }
  }
// fin test température et humidité

// detecteur proximité
 
  Dist = ultrason(T); //convertion la tension en température
  lcd.setCursor(2, 1);
  lcd.print(Dist,1);
  lcd.print(" ");

  if (bDist==1) {
    timerDist = millis()-timerDist0;
    if (timerDist >= tempoDist) {
      digitalWrite(Led_V_pin, LOW);
//      timerDist0 = 0;
//      timerDist = 0;
      bDist = LOW;
    }
  }
  else{
    if (Dist<=d_lim){
      bDist = HIGH;
      digitalWrite(Led_V_pin, HIGH);
      timerDist0 = millis();
      timerDist = millis()-timerDist0;
    }
  }
// fin test detecteur proximité
// test luminosité
  analogReference(DEFAULT);
  iV1 = analogRead(A3); // lecture numérique de V1 à partir de la pin 'A3'
  iV2 = analogRead(A4); // lecture numérique de V2 à partir de la pin 'A4'
  iDV = iV1-iV2;
  Rldr=10000.0*(1024-iV1)/(iV1-iV2);
  lcd.setCursor(10, 1);
  lcd.print(Rldr,0);
  lcd.print("  ");
  ValLed = min(max((Rldr-Rldr0)/50,0),255);
  analogWrite(Led_B_pin,ValLed);

// fin test luminosité

}


float ultrason(float Tempe) {
  float k = 20.05*sqrt(Tempe+273)/20000;// 0.01717; // k=343.3/20000 = vitesse des US dans l'air / temps en [microseconde] relatif à un aller et retour de l'onde. La distance est ainsi calculée en [cm];
  float dist;
  unsigned long duree;
  unsigned long dureeTot = 0;
  for (int i = 0; i < 5; i++) { // pour une meilleure précision de la distance, on calcule la moyenne de 5 valeurs.
    digitalWrite(trig_pin, LOW);
    delayMicroseconds(2);
    digitalWrite(trig_pin, HIGH);
    delayMicroseconds(10);
    digitalWrite(trig_pin, LOW);
    duree = pulseIn(echo_pin, HIGH);
    dureeTot = dureeTot + duree;
    delay(50); // temporisation pour éviter les échos parasites
  }
  dist = float(dureeTot) * k/5.0;
  return dist;
}

void MCP41010Write(int vMCP41010) {
  digitalWrite(CS,LOW);  // sélectionner le circuit MCP41010
  SPI.transfer(B00010001); // Pour la configuration du mot de commande, se référer à la page 18 datasheet du CI MCP41010
  SPI.transfer(vMCP41010); // Ecriture de la valeur correspondante à la résistance de sortie.
  digitalWrite(CS,HIGH); // de-sélectionner le circuit MCP41010
}

void BP_ON() {
      digitalWrite(Led_R_pin, HIGH);
      tone(Buzzer_pin, 700);
      lcd.setCursor(15, 0);
      lcd.print("?");
}

void BP_OFF() {
      digitalWrite(Led_R_pin, LOW);
      noTone(Buzzer_pin);
      lcd.setCursor(15, 0);
      lcd.print(" ");
}

